searchNodes=[{"doc":"Onnx runtime intepreter for Elixir. Deep Learning inference framework.","ref":"OnnxInterp.html","title":"OnnxInterp","type":"module"},{"doc":"Adjust NMS result to aspect of the input image. (letterbox) Parameters: nms_result - NMS result {:ok, result} [rx, ry] - aspect ratio of the input image","ref":"OnnxInterp.html#adjust2letterbox/2","title":"OnnxInterp.adjust2letterbox/2","type":"function"},{"doc":"Get name of backend NN framework.","ref":"OnnxInterp.html#framework/0","title":"OnnxInterp.framework/0","type":"function"},{"doc":"Ensure that the back-end framework is as expected.","ref":"OnnxInterp.html#framework?/1","title":"OnnxInterp.framework?/1","type":"function"},{"doc":"Get the flat binary from the output tensor on the interpreter. Parameters mod - modules' names or session. index - index of output tensor in the model","ref":"OnnxInterp.html#get_output_tensor/3","title":"OnnxInterp.get_output_tensor/3","type":"function"},{"doc":"Get the propaty of the model. Parameters mod - modules' names","ref":"OnnxInterp.html#info/1","title":"OnnxInterp.info/1","type":"function"},{"doc":"Invoke prediction. Two modes are toggled depending on the type of input data. One is the stateful mode, in which input/output data are stored as model states. The other mode is stateless, where input/output data is stored in a session structure assigned to the application. Parameters mod/session - modules name(stateful) or session structure(stateless). Examples. output_bin = session ( ) # stateless mode |&gt; OnnxInterp . set_input_tensor ( 0 , input_bin ) |&gt; OnnxInterp . invoke ( ) |&gt; OnnxInterp . get_output_tensor ( 0 )","ref":"OnnxInterp.html#invoke/1","title":"OnnxInterp.invoke/1","type":"function"},{"doc":"Execute post processing: nms. Parameters mod - modules' names num_boxes - number of candidate boxes num_class - number of category class boxes - binaries, serialized boxes tensor[ num_boxes ][4]; dtype: float32 scores - binaries, serialized score tensor[ num_boxes ][ num_class ]; dtype: float32 opts iou_threshold: - IOU threshold score_threshold: - score cutoff threshold sigma: - soft IOU parameter boxrepr: - type of box representation :center - center pos and width/height :topleft - top-left pos and width/height :corner - top-left and bottom-right corner pos","ref":"OnnxInterp.html#non_max_suppression_multi_class/5","title":"OnnxInterp.non_max_suppression_multi_class/5","type":"function"},{"doc":"","ref":"OnnxInterp.html#run/1","title":"OnnxInterp.run/1","type":"function"},{"doc":"Put a flat binary to the input tensor on the interpreter. Parameters mod - modules' names or session. index - index of input tensor in the model bin - input data - flat binary, cf. serialized tensor opts - data conversion","ref":"OnnxInterp.html#set_input_tensor/4","title":"OnnxInterp.set_input_tensor/4","type":"function"},{"doc":"Stop the onnx-runtime interpreter. Parameters mod - modules' names","ref":"OnnxInterp.html#stop/1","title":"OnnxInterp.stop/1","type":"function"},{"doc":"Ensure that the model matches the back-end framework. Parameters model - path of model file url - download site","ref":"OnnxInterp.html#validate_model/2","title":"OnnxInterp.validate_model/2","type":"function"},{"doc":"","ref":"OnnxInterp.URL.html","title":"OnnxInterp.URL","type":"module"},{"doc":"Download and process data from url. Parameters url - download site url func - function to process downloaded data","ref":"OnnxInterp.URL.html#download/2","title":"OnnxInterp.URL.download/2","type":"function"},{"doc":"Download and save the file from url. Parameters url - download site url path - distination path of downloaded file name - name for the downloaded file","ref":"OnnxInterp.URL.html#download/3","title":"OnnxInterp.URL.download/3","type":"function"},{"doc":"Onnx runtime interpreter for Elixir. It is a Deep Learning inference framework that can be used in the same way as my TflInterp. [ ATTENSION : OnnxInterp v0.1.8 is last release! OnnxInterp will be integrated into NNInterp, so please use NNIterp instead.]","ref":"readme.html","title":"OnnxInterp","type":"extras"},{"doc":"I have confirmed it works in the following OS environment. Windows 10 with Visual C++ 2019 WSL2/Ubuntu 20.04 Linux Mint 20 &quot;Ulyana&quot;","ref":"readme.html#platform","title":"OnnxInterp - Platform","type":"extras"},{"doc":"cmake 3.13 or later is required. Visual C++ 2019 for Windows.","ref":"readme.html#requirements","title":"OnnxInterp - Requirements","type":"extras"},{"doc":"You can install it by adding onnx_interp to the mix.exs dependency list as follows: def deps do [ { :onnx_interp , &quot;~&gt; 0.1.9&quot; } ] end","ref":"readme.html#installation","title":"OnnxInterp - Installation","type":"extras"},{"doc":"You get the trained Onnx model and save it in a directory that your application can read. &quot;your-app/priv&quot; may be good choice. $ cp your-trained-model.onnx ./priv Next, you will create a module that interfaces with the deep learning model. The module will need pre-processing and post-processing in addition to inference processing, as in the example following. OnnxInterp provides inference processing only. You put use OnnxInterp at the beginning of your module, specify the model path as an optional argument. In the inference section, you will put data input to the model ( OnnxInterp.set_input_tensor/3 ), inference execution ( OnnxInterp.invoke/1 ), and inference result retrieval ( OnnxInterp.get_output_tensor/2 ). defmodule YourApp.YourModel do use OnnxInterp, model: &quot;priv/your-trained-model.onnx&quot; def predict(data) do # preprocess # to convert the data to be inferred to the input format of the model. input_bin = convert-float32-binaries(data) # inference # typical I/O data for Onnx models is a serialized 32-bit float tensor. output_bin = __MODULE__ |&gt; OnnxInterp.set_input_tensor(0, input_bin) |&gt; OnnxInterp.invoke() |&gt; OnnxInterp.get_output_tensor(0) # postprocess # add your post-processing here. # you may need to reshape output_bin to tensor at first. tensor = output_bin |&gt; Nx.from_binary({:f, 32}) |&gt; Nx.reshape({size-x, size-y, :auto}) * your-postprocessing * ... end end","ref":"readme.html#basic-usage","title":"OnnxInterp - Basic Usage","type":"extras"},{"doc":"There is Fast Neural Style Transfer: Candy demo in the demo directory. This demo artistically converts a photo of a frog 'flog.jpg' in the demo directory and saves it as 'candy.jpg'. First, you download the trained DNN model &quot;candy-9.onnx&quot; from the following URL and place it in the demo directory. candy-9.onnx: https://github.com/onnx/models/raw/main/vision/style_transfer/fast_neural_style/model/candy-9.onnx You can run the demo by following these steps. $ cd demo $ mix deps.get $ mix run -e &quot;DemoCandy.run&quot; You get &quot;candy.jpg&quot; in current directory. Let's enjoy ;-)","ref":"readme.html#demo","title":"OnnxInterp - Demo","type":"extras"},{"doc":"OnnxInterp is licensed under the Apache License Version 2.0.","ref":"readme.html#license","title":"OnnxInterp - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Major Features and Improvements feed back from AxonInterp project. added demo_yolov4. revised documents.","ref":"changelog.html#release-0-1-9-dec-5-2022","title":"Changelog - Release 0.1.9(Dec 5 2022)","type":"extras"},{"doc":"Major Features and Improvements added the ability to download model files from the url. added the ability to give hints about I/O tensor of the model. added example of ViT image classification.","ref":"changelog.html#release-0-1-8-nov-13-2022","title":"Changelog - Release 0.1.8(Nov 13 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes Fixed compilers config in mix.exs.","ref":"changelog.html#release-0-1-7-sep-5-2022","title":"Changelog - Release 0.1.7(Sep 5 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes Fixed a miscalculation in the size of the input tensor.","ref":"changelog.html#release-0-1-6-aug-30-2022","title":"Changelog - Release 0.1.6(Aug 30 2022)","type":"extras"},{"doc":"Breaking Changes the previous download source of nlohmann-json is gone, so changed to another one.","ref":"changelog.html#release-0-1-5-aug-2-2022","title":"Changelog - Release 0.1.5(Aug 2 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes added two more ways to specify box in NMS. include NanoDet plus object detection demo. rename the folder of Candy demo.","ref":"changelog.html#release-0-1-4-aug-2-2022","title":"Changelog - Release 0.1.4(Aug 2 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes fixed command message of non_max_suppression_multi_class/7. include livebook demo: Semantic Segmentation for Self Driving Cars by UNet. include YOLOv7 object detection demo.","ref":"changelog.html#release-0-1-3-jul-09-2022","title":"Changelog - Release 0.1.3(Jul 09 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes confirmed it works in Linux Mint 20.","ref":"changelog.html#release-0-1-2-may-20-2022","title":"Changelog - Release 0.1.2(May 20 2022)","type":"extras"},{"doc":"Experimental version","ref":"changelog.html#release-0-1-1-may-18-2022","title":"Changelog - Release 0.1.1(May 18 2022)","type":"extras"},{"doc":"File . cd! ( __DIR__ ) # for windows JP System . shell ( &quot;chcp 65001&quot; ) Mix . install ( [ { :onnx_interp , &quot;~&gt; 0.1.8&quot; } , { :cimg , &quot;~&gt; 0.1.14&quot; } , { :kino , &quot;~&gt; 0.7.0&quot; } ] )","ref":"candy.html","title":"Fast Neural Style Transfer","type":"extras"},{"doc":"Fast Neural Style Transfer https://github.com/onnx/models/tree/main/vision/style_transfer/fast_neural_style fast-neural-style in PyTorch https://github.com/pytorch/examples/tree/main/fast_neural_style Thanks a lot!!!","ref":"candy.html#0-original-work","title":"Fast Neural Style Transfer - 0.Original work","type":"extras"},{"doc":"System . put_env ( &quot;MODEL&quot; , &quot;candy&quot; ) # select dnn model in {&quot;mosaic&quot;, &quot;candy&quot;, &quot;rain&quot;, &quot;udnie&quot;, &quot;point&quot;} at compile time. { model_name , model_path , model_url } = System . get_env ( &quot;MODEL&quot; , &quot;candy&quot; ) |&gt; String . downcase ( ) |&gt; tap ( &amp; IO . puts ( &quot;-- COMPLE the deme for \\&quot; \#{ &amp;1 } \\&quot; .&quot; ) ) |&gt; case do &quot;mosaic&quot; -&gt; { &quot;Mosaic&quot; , &quot;./model/mosaic-9.onnx&quot; , &quot;https://github.com/onnx/models/raw/main/vision/style_transfer/fast_neural_style/model/mosaic-9.onnx&quot; } &quot;candy&quot; -&gt; { &quot;Candy&quot; , &quot;./model/candy-9.onnx&quot; , &quot;https://github.com/onnx/models/raw/main/vision/style_transfer/fast_neural_style/model/candy-9.onnx&quot; } &quot;rain&quot; -&gt; { &quot;RainPrincess&quot; , &quot;./model/rain-princess-9.onnx&quot; , &quot;https://github.com/onnx/models/raw/main/vision/style_transfer/fast_neural_style/model/rain-princess-9.onnx&quot; } &quot;udnie&quot; -&gt; { &quot;Udnie&quot; , &quot;./model/udnie-9.onnx&quot; , &quot;https://github.com/onnx/models/raw/main/vision/style_transfer/fast_neural_style/model/udnie-9.onnx&quot; } &quot;point&quot; -&gt; { &quot;Pointilism&quot; , &quot;./model/pointilism-9.onnx&quot; , &quot;https://github.com/onnx/models/raw/main/vision/style_transfer/fast_neural_style/model/pointilism-9.onnx&quot; } unknown -&gt; raise ( &quot;** COMILE ERROR: unknon dnn model: &#39; \#{ unknown } &#39;. it must be one of {vit, vgg16, resnet18} **&quot; ) end defmodule Candy do @name model_name @model model_path @url model_url alias OnnxInterp , as : NNInterp use NNInterp , model : @model , url : @url def apply ( img ) do input0 = img |&gt; CImg . resize ( { 224 , 224 } ) |&gt; CImg . to_binary ( [ { :dtype , &quot;&lt;f4&quot; } , { :range , { 0.0 , 255.0 } } , :nchw ] ) output0 = session ( ) |&gt; NNInterp . set_input_tensor ( 0 , input0 ) |&gt; NNInterp . invoke ( ) |&gt; NNInterp . get_output_tensor ( 0 ) CImg . from_binary ( output0 , 224 , 224 , 1 , 3 , [ { :dtype , &quot;&lt;f4&quot; } , { :range , { 0.0 , 255.0 } } , :nchw ] ) end def info ( ) do %{ name : @name , path : @model , url : @url } end end Launch Candy . # OnnxInterp.stop(Candy) Candy . start_link ( [ ] )","ref":"candy.html#implementation-with-onnxinterp-in-elixir","title":"Fast Neural Style Transfer - Implementation with OnnxInterp in Elixir","type":"extras"},{"doc":"Load a photo and apply Candy to it. filename = &quot;flog.jpg&quot; CImg . load ( filename ) # display the image. |&gt; tap ( fn img -&gt; Kino . render ( CImg . resize ( img , { 224 , 224 } ) |&gt; CImg . display_kino ( :jpeg ) ) end ) # inference. |&gt; Candy . apply ( ) |&gt; CImg . display_kino ( :jpeg )","ref":"candy.html#3-let-s-try-it","title":"Fast Neural Style Transfer - 3.Let's try it","type":"extras"},{"doc":"&amp;#9633;","ref":"candy.html#4-til","title":"Fast Neural Style Transfer - 4.TIL ;-)","type":"extras"},{"doc":"File . cd! ( __DIR__ ) # for windows JP System . shell ( &quot;chcp 65001&quot; ) Mix . install ( [ { :onnx_interp , &quot;~&gt; 0.1.8&quot; } , { :cimg , &quot;~&gt; 0.1.14&quot; } , { :nx , &quot;~&gt; 0.4.0&quot; } , { :kino , &quot;~&gt; 0.7.0&quot; } ] )","ref":"image_classify.html","title":"image classification","type":"extras"},{"doc":"ResNet18:&lt;br&gt; ONNX Model Zoo/ResNet - https://github.com/onnx/models/tree/main/vision/classification/resnet VGG16&lt;br&gt; ONNX Model Zoo/VGG - https://github.com/onnx/models/tree/main/vision/classification/vgg ViT&lt;br&gt; Vision Transformer (ViT) in PyTorch - https://github.com/lukemelas/PyTorch-Pretrained-ViT &lt;br&gt;(convert this model to ONNX with torch.onnx.export()) Thanks a lot!!!","ref":"image_classify.html#original-work","title":"image classification - Original work","type":"extras"},{"doc":"Please select a DNN model. {&quot;resnet18&quot;, &quot;vgg16&quot;, &quot;vit&quot;} System . put_env ( &quot;MODEL&quot; , &quot;resnet18&quot; ) # select dnn model in {&quot;vit&quot;, &quot;vgg16&quot;, &quot;resnet18&quot;} at compile time. { model_name , model_path , { model_width , model_height } , model_url } = System . get_env ( &quot;MODEL&quot; , &quot;resnet18&quot; ) |&gt; String . downcase ( ) |&gt; tap ( &amp; IO . puts ( &quot;-- COMPLE the deme for \\&quot; \#{ &amp;1 } \\&quot; .&quot; ) ) |&gt; case do &quot;vit&quot; -&gt; { &quot;ViT&quot; , &quot;./model/vit.onnx&quot; , { 384 , 384 } , &quot;https://drive.google.com/uc??authuser=0&amp;export=download&amp;confirm=t&amp;id=1L2sDNeK7CXdiMYflgCN8dWkrP2397ULv&quot; } &quot;vgg16&quot; -&gt; { &quot;VGG16&quot; , &quot;./model/vgg16-7.onnx&quot; , { 224 , 224 } , &quot;https://github.com/onnx/models/raw/main/vision/classification/vgg/model/vgg16-7.onnx&quot; } &quot;resnet18&quot; -&gt; { &quot;ResNet18&quot; , &quot;./model/resnet18-v1-7.onnx&quot; , { 224 , 224 } , &quot;https://github.com/onnx/models/raw/main/vision/classification/resnet/model/resnet18-v1-7.onnx&quot; } unknown -&gt; raise ( &quot;** COMILE ERROR: unknon dnn model: &#39; \#{ unknown } &#39;. it must be one of {vit, vgg16, resnet18} **&quot; ) end defmodule ImageClassify do @name model_name @model model_path @url model_url @width model_width @height model_height alias OnnxInterp , as : NNInterp use NNInterp , model : @model , url : @url @imagenet1000 ( for item &lt;- File . stream! ( &quot;./model/imagenet1000.label&quot; ) do String . trim_trailing ( item ) end ) |&gt; Enum . with_index ( &amp; { &amp;2 , &amp;1 } ) |&gt; Enum . into ( %{ } ) def apply ( img , top \\\\ 1 ) do # preprocess input0 = img |&gt; CImg . resize ( { @width , @height } ) |&gt; CImg . to_binary ( [ { :gauss , { { 123.7 , 58.4 } , { 116.3 , 57.1 } , { 103.5 , 57.4 } } } , :nchw ] ) # prediction output0 = session ( ) |&gt; NNInterp . set_input_tensor ( 0 , input0 ) |&gt; NNInterp . invoke ( ) |&gt; NNInterp . get_output_tensor ( 0 ) |&gt; Nx . from_binary ( :f32 ) |&gt; Nx . reshape ( { 1000 } ) # postprocess # softmax Nx . exp ( output0 ) |&gt; then ( fn exp -&gt; Nx . divide ( exp , Nx . sum ( exp ) ) end ) |&gt; Nx . argsort ( direction : :desc ) |&gt; Nx . slice ( [ 0 ] , [ top ] ) |&gt; Nx . to_flat_list ( ) |&gt; Enum . map ( &amp; @imagenet1000 [ &amp;1 ] ) end def info ( ) do %{ name : @name , path : @model , shape : { @width , @height } , url : @url } end end Launch ImageClassify . # OnnxInterp.stop(ImageClassify) ImageClassify . start_link ( [ ] ) ImageClassify . info ( )","ref":"image_classify.html#implementation-with-onnxinterp-in-elixir","title":"image classification - Implementation with OnnxInterp in Elixir","type":"extras"},{"doc":"Load a photo and apply ImageClassify to it. filename = &quot;lion.jpg&quot; CImg . load ( filename ) # display the image. |&gt; tap ( fn img -&gt; Kino . render ( CImg . display_kino ( img , :jpeg ) ) end ) # inference. |&gt; ImageClassify . apply ( ) |&gt; tap ( fn _ -&gt; IO . puts ( &quot; \#{ ImageClassify . info ( ) . name } answers:&quot; ) end ) |&gt; IO . inspect ( label : &quot;&#39; \#{ filename } &#39; is &quot; ) :ok","ref":"image_classify.html#let-s-try-it","title":"image classification - Let's try it","type":"extras"},{"doc":"","ref":"image_classify.html#til","title":"image classification - TIL ;-)","type":"extras"},{"doc":"How to get pre-trained ViT onnx model. You need install &quot;pytorch_pretrained_vit&quot; and covert the model beforehand. $ pip install pytorch_pretrained_vit # convert Pytorch ViT model to ONNX. import torch from pytorch_pretrained_vit import ViT model = ViT('B_16_imagenet1k', pretrained=True) model.eval() dummy_input = torch.randn(1, 3, 384, 384) os.makedirs(&quot;data&quot;, exist_ok=True) torch.onnx.export(model, dummy_input, &quot;vit.onnx&quot;, verbose=False, input_names=[&quot;input.0&quot;], output_names=[&quot;output.0&quot;], export_params=True ) &amp;#9633;","ref":"image_classify.html#appendix","title":"image classification - Appendix","type":"extras"},{"doc":"File . cd! ( __DIR__ ) # for windows JP # System.shell(&quot;chcp 65001&quot;) Mix . install ( [ { :onnx_interp , &quot;~&gt; 0.1.8&quot; } , { :cimg , &quot;~&gt; 0.1.14&quot; } , { :postdnn , &quot;~&gt; 0.1.5&quot; } , { :nx , &quot;~&gt; 0.4.0&quot; } , { :kino , &quot;~&gt; 0.7.0&quot; } ] )","ref":"nanodet.html","title":"NanoDet plus","type":"extras"},{"doc":"NanoDet-Plus https://github.com/RangiLyu/nanodet Thanks a lot!!!","ref":"nanodet.html#0-original-work","title":"NanoDet plus - 0.Original work","type":"extras"},{"doc":"defmodule NanoDet do @moduledoc &quot;&quot;&quot; Original work NanoDet-Plus - https://github.com/RangiLyu/nanodet &quot;&quot;&quot; alias OnnxInterp , as : NNInterp use NNInterp , label : &quot;./model/coco.label&quot; , model : &quot;./model/NanoDet-Plus-m-416.onnx&quot; , url : &quot;https://github.com/RangiLyu/nanodet/releases/download/v1.0.0-alpha-1/nanodet-plus-m_416.onnx&quot; @width 416 @height 416 @grid PostDNN . meshgrid ( { @width , @height } , [ 8 , 16 , 32 , 64 ] , [ :normalize ] ) @arm Nx . iota ( { 8 } ) def apply ( img ) do # preprocess input0 = img |&gt; CImg . resize ( { @width , @height } ) |&gt; CImg . to_binary ( [ { :gauss , { { 103.53 , 57.375 } , { 116.28 , 57.12 } , { 123.675 , 58.395 } } } , :nchw , :bgr ] ) # prediction output0 = __MODULE__ |&gt; OnnxInterp . set_input_tensor ( 0 , input0 ) |&gt; OnnxInterp . invoke ( ) |&gt; OnnxInterp . get_output_tensor ( 0 ) |&gt; Nx . from_binary ( :f32 ) |&gt; Nx . reshape ( { :auto , 112 } ) # postprocess scores = Nx . slice_along_axis ( output0 , 0 , 80 , axis : 1 ) boxes = Nx . slice_along_axis ( output0 , 80 , 32 , axis : 1 ) # seive candidates [ scores , boxes , grid ] = PostDNN . sieve ( scores , [ boxes , @grid ] , fn t1 -&gt; Nx . reduce_max ( t1 , axes : [ 1 ] ) |&gt; Nx . greater_equal ( 0.25 ) end ) boxes = decode_boxes ( boxes , grid ) OnnxInterp . non_max_suppression_multi_class ( __MODULE__ , Nx . shape ( scores ) , Nx . to_binary ( boxes ) , Nx . to_binary ( scores ) , boxrepr : :corner ) end defp decode_boxes ( boxes , grid ) do [ grid_x , grid_y , pitch ] = Enum . map ( 0 .. 2 , fn i -&gt; Nx . slice_along_axis ( grid , i , 1 , axis : 1 ) |&gt; Nx . squeeze ( ) end ) Enum . map ( 0 .. 3 , fn i -&gt; exp = Nx . slice_along_axis ( boxes , 8 * i , 8 , axis : 1 ) |&gt; Nx . exp ( ) wing = Nx . dot ( exp , @arm ) |&gt; Nx . divide ( Nx . sum ( exp , axes : [ 1 ] ) ) |&gt; Nx . multiply ( pitch ) case i do 0 -&gt; Nx . subtract ( grid_x , wing ) |&gt; Nx . max ( 0.0 ) 1 -&gt; Nx . subtract ( grid_y , wing ) |&gt; Nx . max ( 0.0 ) 2 -&gt; Nx . add ( grid_x , wing ) |&gt; Nx . min ( 1.0 ) 3 -&gt; Nx . add ( grid_y , wing ) |&gt; Nx . min ( 1.0 ) end |&gt; Nx . reshape ( { :auto , 1 } ) end ) |&gt; Nx . concatenate ( axis : 1 ) end end Launch NanoDet . # OnnxInterp.stop(NanoDet) NanoDet . start_link ( [ ] )","ref":"nanodet.html#implementation-with-onnxinterp-in-elixir","title":"NanoDet plus - Implementation with OnnxInterp in Elixir","type":"extras"},{"doc":"defmodule DemoNanoDet do @palette CImg.Util . rand_palette ( &quot;./model/coco.label&quot; ) def run ( filename \\\\ &quot;dog.jpg&quot; ) do img = CImg . load ( filename ) # NanoDet prediciton with { :ok , res } &lt;- NanoDet . apply ( img ) do IO . inspect ( res ) # draw result box Enum . reduce ( res , CImg . builder ( img ) , &amp; draw_item ( &amp;1 , &amp;2 ) ) |&gt; CImg . display_kino ( :jpeg ) end end defp draw_item ( { name , boxes } , canvas ) do color = @palette [ name ] Enum . reduce ( boxes , canvas , fn [ _score , x1 , y1 , x2 , y2 , _index ] , img -&gt; CImg . fill_rect ( img , x1 , y1 , x2 , y2 , color , 0.3 ) end ) end end Load a photo and apply NanoDet to it. DemoNanoDet . run ( &quot;dog.jpg&quot; )","ref":"nanodet.html#let-s-try-it","title":"NanoDet plus - Let's try it","type":"extras"},{"doc":"&amp;#9633;","ref":"nanodet.html#til","title":"NanoDet plus - TIL ;-)","type":"extras"},{"doc":"File . cd! ( __DIR__ ) # for windows JP # System.shell(&quot;chcp 65001&quot;) Mix . install ( [ { :onnx_interp , &quot;~&gt; 0.1.8&quot; } , { :cimg , &quot;~&gt; 0.1.14&quot; } , { :postdnn , &quot;~&gt; 0.1.5&quot; } , { :kino , &quot;~&gt; 0.7.0&quot; } ] )","ref":"yolov4.html","title":"Object Detection: YOLOv4","type":"extras"},{"doc":"Pytorch-YOLOv4 https://github.com/Tianxiaomo/pytorch-YOLOv4 This note usee the pretraind model converted from above project ;-) Thanks a lot!!!","ref":"yolov4.html#0-original-work","title":"Object Detection: YOLOv4 - 0.Original work","type":"extras"},{"doc":"","ref":"yolov4.html#implementation-with-onnxinterp-in-elixir","title":"Object Detection: YOLOv4 - Implementation with OnnxInterp in Elixir","type":"extras"},{"doc":"Model&lt;br&gt; yolov4_1_3_608_608_static.onnx Pre-processing&lt;br&gt; Resize the input image to the size {608,608}, normalize to {0.0,1.0} and transpose NCHW. Post-processing&lt;br&gt; Filtering Boxes(output[0]) and Scores(output[1]) with Multi-class Non Maximum Suppression. defmodule YOLOv4 do @moduledoc &quot;&quot;&quot; Original work: Pytorch-YOLOv4 - https://github.com/Tianxiaomo/pytorch-YOLOv4 &quot;&quot;&quot; alias OnnxInterp , as : NNInterp use NNInterp , model : &quot;./model/yolov4_1_3_608_608_static.onnx&quot; , url : &quot;https://github.com/shoz-f/onnx_interp/releases/download/models/yolov4_1_3_608_608_static.onnx&quot; , inputs : [ f32 : { 1 , 3 , 608 , 608 } ] , outputs : [ f32 : { 1 , 22743 , 1 , 4 } , f32 : { 1 , 22743 , 80 } ] def apply ( img ) do # preprocess input0 = img |&gt; CImg . resize ( { 608 , 608 } ) |&gt; CImg . to_binary ( [ { :range , { 0.0 , 1.0 } } , :nchw ] ) # prediction outputs = session ( ) |&gt; NNInterp . set_input_tensor ( 0 , input0 ) |&gt; NNInterp . invoke ( ) # postprocess boxes = NNInterp . get_output_tensor ( outputs , 0 ) scores = NNInterp . get_output_tensor ( outputs , 1 ) PostDNN . non_max_suppression_multi_class ( { 22743 , 80 } , boxes , scores , boxrepr : :corner , label : &quot;./model/coco.label&quot; ) end end Launch YOLOv4 . # OnnxInterp.stop(Resnet18) YOLOv4 . start_link ( [ ] ) Display the properties of the YOLOv4 model. OnnxInterp . info ( YOLOv4 )","ref":"yolov4.html#1-defining-the-inference-module-yolov4","title":"Object Detection: YOLOv4 - 1.Defining the inference module: YOLOv4","type":"extras"},{"doc":"defmodule LiveYOLOv4 do @palette CImg.Util . rand_palette ( &quot;./model/coco.label&quot; ) def run ( path ) do img = CImg . load ( path ) with { :ok , res } &lt;- YOLOv4 . apply ( img ) do IO . inspect ( res ) Enum . reduce ( res , CImg . builder ( img ) , &amp; draw_item ( &amp;1 , &amp;2 ) ) |&gt; CImg . display_kino ( :jpeg ) end end defp draw_item ( { name , boxes } , canvas ) do color = @palette [ name ] Enum . reduce ( boxes , canvas , fn [ _score , x1 , y1 , x2 , y2 , _index ] , canvas -&gt; [ x1 , y1 , x2 , y2 ] = PostDNN . clamp ( [ x1 , y1 , x2 , y2 ] , { 0.0 , 1.0 } ) CImg . fill_rect ( canvas , x1 , y1 , x2 , y2 , color , 0.35 ) end ) end end","ref":"yolov4.html#2-defining-execution-module-liveyolov4","title":"Object Detection: YOLOv4 - 2.Defining execution module LiveYOLOv4","type":"extras"},{"doc":"LiveYOLOv4 . run ( &quot;dog.jpg&quot; )","ref":"yolov4.html#3-let-s-try-it","title":"Object Detection: YOLOv4 - 3.Let's try it","type":"extras"},{"doc":"&amp;#9633;","ref":"yolov4.html#appendix","title":"Object Detection: YOLOv4 - Appendix","type":"extras"}]